import java.util.Iterator;


public class SimplifiedTextMergeViewer {
	
	private boolean fHighlightRanges;
	
	private boolean fShowCurrentOnly2;
	
	private ChangeDiffs fChangeDiffs;
	
	public static Object Default_Color = new Object();
	
	public static int LW = 0;
	
	public void paintSides(GC g, MergeSourceViewer tp, Canvas canvas, boolean right){
		
		Display display= canvas.getDisplay();

		if (! fHighlightRanges)
			return;

		if (fChangeDiffs != null) {
				
			Iterator e= fChangeDiffs.iterator();
			while (e.hasNext()) {
				Diff diff= (Diff) e.next();
				
				if (diff.isDeleted())
					continue;
				
				if (fShowCurrentOnly2 && !isCurrentDiff(diff))
					continue;

				Point region= new Point(0, 0);
				tp.getLineRange(diff.getPosition(tp), region);	
					
				g.setBackground(getColor(display, getFillColor(diff)));
	
				g.setLineWidth(0 /* LW */);
				g.setForeground(getColor(display, getStrokeColor(diff)));
			}
		}
	}
	
	private Object getColor(Display display, Object obj){
		return null;
	}
	
	private Object getFillColor(Diff diff){
		return null;
	}
	
	private Object getStrokeColor(Diff diff){
		return null;
	}
	
	public Diff handleMouseInSides(Canvas canvas, MergeSourceViewer msv, int my) {

			int lineHeight= msv.getTextWidget().getLineHeight();
			int visibleHeight= msv.getViewportHeight();

			if (! fHighlightRanges)
				return null;

			if (fChangeDiffs != null) {
				int shift= msv.getVerticalScrollOffset() + (2-LW);

				Iterator e= fChangeDiffs.iterator();
				while (e.hasNext()) {
				
					Diff diff= (Diff) e.next();
					if (diff.isDeleted())
						continue;

					if (fShowCurrentOnly2 && !isCurrentDiff(diff))
						continue;

					Point region= new Point(0, 0);
					msv.getLineRange(diff.getPosition(msv), region);
					int y= (region.x * lineHeight) + shift;
					int h= region.y * lineHeight;

					if (my >= y && my < y+h)
						return diff;
				}
			}
			return null;
		}

	public boolean isCurrentDiff(Diff diff){
		return false;
	}
	
	
}

class Canvas{
	
	Object getBackground(){
		return null;
	}
	
	Display getDisplay(){ 
		return new Display();
	}
	
	Point getSize(){
		return new Point(0, 0);
	}
}

class ChangeDiffs{
	Iterator iterator(){
		return null;
	}
}

class Diff{

	Point getPosition(MergeSourceViewer tp){
		return new Point(0, 0);
	}
	
	boolean isDeleted(){
		return false;
	}
}

class Display{

	Object getSystemColor(Object setting){
		return null;
	}
}


class GC{
	
	void drawRectangle(int x1, int x2, int y1, int y2){
		
	}
	
	void setBackground(Object obj){
		
	}
	
	void setForeground(Object obj){
		
	}
	
	public void setLineWidth(int i){
		
	}
	
	void fillRectangle(int x1, int x2, int x3, int x4){
		
	}
}

class MergeSourceViewer{
	
	void getLineRange(Point position, Point region){
		
	}
	
	TextWidget getTextWidget(){
		return new TextWidget();
	}
	
	int getVerticalScrollOffset(){
		return 0;
	}
	
	int getViewportHeight(){
		return 0;
	}
}

class Point{
	int x, y;
	
	Point(int i, int j){
		x = i;
		y = j;
	}
}

class TextWidget{
	int getLineHeight(){
		return 0;
	}
}
